// Library with common functions
var utils = {};

// Wait for time milliseconds
utils.wait = function(time) {
  var wait_d = $.Deferred();
  setTimeout(function() {
    wait_d.resolve();
  }, time);
  return wait_d;
};

// Show SU modal messagebox
utils.messagebox = function(text) {
  return ruby.call('messagebox', [text]);
};

utils.str_format = function(str, replacements) {
  var index = 0;
  var new_str = str;
  while (new_str.match('%s')) {
    new_str = new_str.replace(/%s/, replacements[index]);
  }
  return new_str;
};

// Extension of Handlebars library
var HandlebarsExt = {
  'compileTemplate': function(id) {
    var templateScript = $('#'+id).html();
    return Handlebars.compile(templateScript);
  },
  'addPartial': function(name, id) {
    var template = HandlebarsExt.compileTemplate(id);
    Handlebars.registerPartial(name, template);
  }
};

// Handlebars helper to check element inclusion into array
Handlebars.registerHelper('includes', function(list, elem) {
  return ($.inArray(elem, list) >= 0);
});

// Handlebars helper to check array emptiness
Handlebars.registerHelper('empty', function(list, elem) {
  return ($.inArray(elem, list) >= 0);
});

Handlebars.registerHelper('isHtmlDialog', function() {
  return ruby.isHtmlDialog;
});
